/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_BIOSTRUCT3D_MOLECULAR_SURFACE_H_
#define _GB2_BIOSTRUCT3D_MOLECULAR_SURFACE_H_


#include <datatype/BioStruct3D.h>
#include <QtCore/QVector>
#include <QtGui/QAction>
#include "GeomUtils.h"

namespace GB2 {

template<class T> inline T sqr(const T& x) { return x*x; }

class GB2_COREAPI_EXPORT MolecularSurface {
static const float TOLERANCE;
public:
    MolecularSurface();
    void calculate(const QList<SharedAtom>& atoms);
    void calculate(const BioStruct3D& bioStruct);
    QVector<Vector3D> vertices;
    QVector<Face> faces;
    static QList<SharedAtom> findAtomNeighbors(const SharedAtom& a, const QList<SharedAtom>& atoms);
    static GeodesicSphere getAtomSurfaceDots(const SharedAtom& a, int fragmentationLevel);
    static bool vertexNeighboursOneOf(const Vector3D& v, const QList<SharedAtom>& atoms);
};


} //namespace

#endif //_GB2_BIOSTRUCT3D_MOLECULAR_SURFACE_H_

