/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _PRIMER3_TASK_H_
#define _PRIMER3_TASK_H_ 1
#include <core_api/Task.h>
#include "primer3_main.h"
#include "boulder_input.h"

namespace GB2 {


class Primer3Task : public Task {
    Q_OBJECT
public:    
    void run();    
    Task::ReportResult report();    
    Primer3Task(primer_args *, seq_args *);
    ~Primer3Task();
    pair_array_t getBestPairs();
    primer_rec *getLeftPrimers();
    primer_rec *getRightPrimers();
    primer_rec *getOligos();
private:
    primer_args *pa;
    seq_args *sa;
    primers_t primers;
    pair_array_t best_pairs;
};


} //namespace

#endif //_PRIMER3_TASK_H_